!  NAM
!
!   DESCRIPTION
!   Phase shift and split step migration plus interpolation
!
!   USAGE
!     Ph3D_MP < in.H > out.H par=par.P apply_split_step=
!
!%

program NAM

  use sep
  use gendown3d_mod
  use param_nam_mod

  use NAM_types
  use NAM_mod

  implicit none


 


  type (NAM_param_type) NAM_par
  logical adj,add
  logical datuming,prestack
  integer stat,getch
  external getch
  character(len=128) tag_data,tag_mod

  call initpar()
  call sep_begin_prog()

  tag_data='Image'
  tag_mod='Data'

  call from_param('datuming',datuming,.false.)
  call from_param('add',add,.false.)
  call from_param('adj',adj,.false.)


  if(datuming) then
    tag_data='Down_data'
    tag_mod='Data'

    call param_NAM(NAM_par)
    call init_NAM_par(NAM_par)
    call gendown3d_init(verb=.true.,init_down_oper=NAM_init)

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  NAM_down_oper,NAM_scatter_oper)
  !}
  else
  !{

    tag_data='Image'
    tag_mod='Data'

    call param_NAM(NAM_par)
    call init_NAM_par(NAM_par)
    call gendown3d_init(verb=.false.,init_down_oper=NAM_init)

   stat=gendown3d(adj,add,tag_mod,tag_data, &
                  NAM_down_oper,NAM_scatter_oper)
  !}
  end if


   call sep_end_prog()
  stop	
end program NAM
